"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Slider = _interopRequireDefault(require("./Slider"));

var _Map = _interopRequireDefault(require("./Map"));

var _lodash = _interopRequireDefault(require("lodash.throttle"));

var _tinycolor = _interopRequireDefault(require("tinycolor2"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var ColorPicker =
/*#__PURE__*/
function (_Component) {
  _inherits(ColorPicker, _Component);

  function ColorPicker(props) {
    var _this;

    _classCallCheck(this, ColorPicker);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ColorPicker).call(this, props));
    var c = (0, _tinycolor["default"])(_this.props.color).toHsv();
    _this.state = {
      color: _this.toPercentage(c)
    };
    _this.throttle = (0, _lodash["default"])(function (fn, data) {
      fn(data);
    }, 100);
    _this.handleSaturationValueChange = _this.handleSaturationValueChange.bind(_assertThisInitialized(_this));
    _this.handleHueChange = _this.handleHueChange.bind(_assertThisInitialized(_this));
    _this.handleAlphaChange = _this.handleAlphaChange.bind(_assertThisInitialized(_this));
    _this.showLastValue = _this.showLastValue.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(ColorPicker, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (!_tinycolor["default"].equals(nextProps.color, this.state.color)) {
        var c = (0, _tinycolor["default"])(nextProps.color).toHsv();
        this.setState({
          color: this.toPercentage(c)
        });
      }
    }
  }, {
    key: "toPercentage",
    value: function toPercentage(hsv) {
      var h = hsv.h,
          s = hsv.s,
          v = hsv.v,
          a = hsv.a;
      return {
        h: h,
        s: s * 100,
        v: v * 100,
        a: a
      };
    }
  }, {
    key: "handleHueChange",
    value: function handleHueChange(h) {
      var _this$state$color = this.state.color,
          s = _this$state$color.s,
          v = _this$state$color.v,
          a = _this$state$color.a;
      this.update({
        h: h,
        s: s,
        v: v,
        a: a
      });
    }
  }, {
    key: "handleSaturationValueChange",
    value: function handleSaturationValueChange(s, v) {
      var _this$state$color2 = this.state.color,
          h = _this$state$color2.h,
          a = _this$state$color2.a;
      this.update({
        h: h,
        s: s,
        v: v,
        a: a
      });
    }
  }, {
    key: "handleAlphaChange",
    value: function handleAlphaChange(a) {
      var _this$state$color3 = this.state.color,
          h = _this$state$color3.h,
          s = _this$state$color3.s,
          v = _this$state$color3.v;
      this.update({
        h: h,
        s: s,
        v: v,
        a: a
      });
    }
  }, {
    key: "getAlpha",
    value: function getAlpha() {
      return this.state.color.a === undefined ? 1 : this.state.color.a;
    }
  }, {
    key: "getBackgroundHue",
    value: function getBackgroundHue() {
      return (0, _tinycolor["default"])({
        h: this.state.color.h,
        s: 100,
        v: 100
      }).toRgbString();
    }
  }, {
    key: "getBackgroundGradient",
    value: function getBackgroundGradient() {
      var _this$state$color4 = this.state.color,
          h = _this$state$color4.h,
          s = _this$state$color4.s,
          v = _this$state$color4.v;
      var opaque = (0, _tinycolor["default"])({
        h: h,
        s: s,
        v: v,
        a: 1
      }).toRgbString();
      return "linear-gradient(to right, rgba(0,0,0,0) 0%, ".concat(opaque, " 100%)");
    }
  }, {
    key: "update",
    value: function update(color) {
      var _this2 = this;

      this.setState({
        color: color
      }, function () {
        _this2.throttle(_this2.props.onChange, _this2.output());
      });
    }
  }, {
    key: "output",
    value: function output() {
      var c = (0, _tinycolor["default"])(this.state.color);
      return {
        hsl: c.toHsl(),
        hex: c.toHex(),
        hexString: c.toHexString(),
        rgb: c.toRgb(),
        rgbString: c.toRgbString()
      };
    }
  }, {
    key: "showLastValue",
    value: function showLastValue() {
      this.props.onComplete && this.props.onComplete(this.output());
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state$color5 = this.state.color,
          h = _this$state$color5.h,
          s = _this$state$color5.s,
          v = _this$state$color5.v,
          a = _this$state$color5.a;
      return _react["default"].createElement("div", {
        className: this.props.className || 'ColorPicker',
        style: this.props.style
      }, _react["default"].createElement(_Slider["default"], {
        className: "HueSlider",
        vertical: true,
        value: h,
        type: "hue",
        max: 360,
        onChange: this.handleHueChange,
        onComplete: this.showLastValue,
        style: {
          right: '1.3em',
          bottom: this.props.opacity ? '2.5em' : '1.3em'
        },
        trackStyle: {
          borderRadius: '1em',
          background: "linear-gradient(to bottom,\n              #f00 0%,\n              #f0f 17%,\n              #00f 33%,\n              #0ff 50%,\n              #0f0 67%,\n              #ff0 83%,\n              #f00 100%\n            )"
        },
        pointerStyle: {
          boxShadow: 'inset 0 0 0 1px #ccc,0 1px 2px #ccc',
          borderRadius: '100%'
        }
      }), this.props.opacity && _react["default"].createElement(_Slider["default"], {
        className: "OpacitySlider",
        type: "opacity",
        value: a,
        max: 1,
        background: this.getBackgroundGradient(),
        onChange: this.handleAlphaChange,
        onComplete: this.showLastValue,
        style: {
          bottom: '1.3em',
          right: '2.5em',
          height: 8,
          background: '#fff url("data:image/gif;base64,R0lGODdhEAAQAPEAAMvLy8zMzP///wAAACwAAAAAEAAQAEACHYxvosstCAEMrq6Jj812Y59NIDQipdY5XLWqH4sVADs=") repeat',
          backgroundSize: '8px 8px'
        },
        trackStyle: {
          borderRadius: '1em',
          background: 'linear-gradient(to right, rgba(255,255,255,0) 0%, #FFF 100%)'
        },
        pointerStyle: {
          boxShadow: 'inset 0 0 0 1px #ccc,0 1px 2px #ccc',
          borderRadius: '100%'
        }
      }), _react["default"].createElement(_Map["default"], {
        x: s,
        y: v,
        max: 100,
        backgroundColor: this.getBackgroundHue(),
        onChange: this.handleSaturationValueChange,
        onComplete: this.showLastValue,
        style: {
          top: 0,
          left: 0,
          right: '2.5em',
          bottom: this.props.opacity ? '2.5em' : '1.3em'
        },
        pointerStyle: {
          borderColor: (0, _tinycolor["default"])(this.state.color).isDark() ? '#fff' : '#000'
        }
      }));
    }
  }]);

  return ColorPicker;
}(_react.Component);

ColorPicker.propTypes = {
  color: _propTypes["default"].string.isRequired,
  onChange: _propTypes["default"].func.isRequired,
  onComplete: _propTypes["default"].func
};
ColorPicker.defaultProps = {
  color: 'rgba(0,0,0,1)'
};
var _default = ColorPicker;
exports["default"] = _default;