"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = draggable;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

var _lodash = _interopRequireDefault(require("lodash.throttle"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var noop = function noop() {};

var getDocument = function getDocument(element) {
  return element.ownerDocument;
};

var clamp = function clamp(val, min, max) {
  return Math.min(Math.max(val, min), max);
};

var getDisplayName = function getDisplayName(WrappedComponent) {
  return WrappedComponent.displayName || WrappedComponent.name || 'Component';
};

function draggable() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return function wrappedInDraggable(WrappedComponent) {
    var Draggable =
    /*#__PURE__*/
    function (_Component) {
      _inherits(Draggable, _Component);

      function Draggable(props) {
        var _this;

        _classCallCheck(this, Draggable);

        _this = _possibleConstructorReturn(this, _getPrototypeOf(Draggable).call(this, props));
        _this.state = {
          active: false
        };
        _this.throttle = (0, _lodash["default"])(function (fn, data) {
          return fn(data);
        }, 30);
        _this.getPercentageValue = _this.getPercentageValue.bind(_assertThisInitialized(_this));
        _this.startUpdates = _this.startUpdates.bind(_assertThisInitialized(_this));
        _this.handleUpdate = _this.handleUpdate.bind(_assertThisInitialized(_this));
        _this.stopUpdates = _this.stopUpdates.bind(_assertThisInitialized(_this));
        _this.getPosition = _this.getPosition.bind(_assertThisInitialized(_this));
        _this.getScaledValue = _this.getScaledValue.bind(_assertThisInitialized(_this));
        _this.updateBoundingRect = _this.updateBoundingRect.bind(_assertThisInitialized(_this));
        _this.updatePosition = _this.updatePosition.bind(_assertThisInitialized(_this));
        return _this;
      }

      _createClass(Draggable, [{
        key: "componentDidMount",
        value: function componentDidMount() {
          this.document = getDocument(_reactDom["default"].findDOMNode(this));
          var window = this.window = this.document.defaultView;
          window.addEventListener('resize', this.updateBoundingRect);
          window.addEventListener('scroll', this.updateBoundingRect);
          this.updateBoundingRect();
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          var window = this.window;
          window.removeEventListener('resize', this.updateBoundingRect);
          window.removeEventListener('scroll', this.updateBoundingRect);
        }
      }, {
        key: "startUpdates",
        value: function startUpdates(e) {
          var document = this.document;
          e.preventDefault();
          var rect = this.updateBoundingRect();
          document.addEventListener('mousemove', this.handleUpdate);
          document.addEventListener('touchmove', this.handleUpdate);
          document.addEventListener('mouseup', this.stopUpdates);
          document.addEventListener('touchend', this.stopUpdates);

          var _this$getPosition = this.getPosition(e),
              x = _this$getPosition.x,
              y = _this$getPosition.y;

          this.setState({
            active: true
          });
          this.updatePosition({
            x: x,
            y: y
          }, rect); // this.throttle(this.updatePosition, { x, y });
        }
      }, {
        key: "handleUpdate",
        value: function handleUpdate(e) {
          if (this.state.active) {
            e.preventDefault();

            var _this$getPosition2 = this.getPosition(e),
                x = _this$getPosition2.x,
                y = _this$getPosition2.y;

            this.updatePosition({
              x: x,
              y: y
            }); // this.throttle(this.updatePosition, { x, y });
          }
        }
      }, {
        key: "stopUpdates",
        value: function stopUpdates() {
          if (this.state.active) {
            var document = this.document;
            document.removeEventListener('mousemove', this.handleUpdate);
            document.removeEventListener('touchmove', this.handleUpdate);
            document.removeEventListener('mouseup', this.stopUpdates);
            document.removeEventListener('touchend', this.stopUpdates);
            this.props.onComplete();
            this.setState({
              active: false
            });
          }
        }
      }, {
        key: "updatePosition",
        value: function updatePosition(_ref) {
          var clientX = _ref.x,
              clientY = _ref.y;
          var rect = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.state.rect;

          if (options.single) {
            var value = this.props.vertical ? (rect.bottom - clientY) / rect.height : (clientX - rect.left) / rect.width;
            return this.props.onChange(this.getScaledValue(value));
          }

          var x = (clientX - rect.left) / rect.width;
          var y = (rect.bottom - clientY) / rect.height;
          return this.props.onChange(this.getScaledValue(x), this.getScaledValue(y));
        }
      }, {
        key: "getPosition",
        value: function getPosition(e) {
          if (e.touches) {
            e = e.touches[0];
          }

          return {
            x: e.clientX,
            y: e.clientY
          };
        }
      }, {
        key: "getPercentageValue",
        value: function getPercentageValue(value) {
          return value / this.props.max * 100 + '%';
        }
      }, {
        key: "getScaledValue",
        value: function getScaledValue(value) {
          return clamp(value, 0, 1) * this.props.max;
        }
        /**
         * Findout the bounding rect - update state to send the rect to WrappedComponent
         * @return {Object} Returns rect for additional logic
         */

      }, {
        key: "updateBoundingRect",
        value: function updateBoundingRect() {
          var rect = _reactDom["default"].findDOMNode(this).getBoundingClientRect();

          this.setState({
            rect: rect
          });
          return rect;
        }
      }, {
        key: "render",
        value: function render() {
          return _react["default"].createElement(WrappedComponent, _extends({}, this.props, this.state, {
            startUpdates: this.startUpdates,
            getPercentageValue: this.getPercentageValue
          }));
        }
      }]);

      return Draggable;
    }(_react.Component);

    Draggable.displayName = "draggable(".concat(getDisplayName(WrappedComponent), ")");
    Draggable.WrappedComponent = WrappedComponent;
    Draggable.propTypes = {
      onChange: _propTypes["default"].func.isRequired,
      onComplete: _propTypes["default"].func,
      max: _propTypes["default"].number
    };
    Draggable.defaultProps = {
      onChange: noop,
      onComplete: noop,
      max: 1
    };
    return (0, _hoistNonReactStatics["default"])(Draggable, WrappedComponent);
  };
}